package web.multitask.trismegistoservices.api;

import org.json.JSONObject;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;

@RestController
@CrossOrigin(origins = "*")
@RequestMapping("console")
public class ConsoleApi {
    @PostMapping("/public/command")
    public ResponseEntity<?> pull(@RequestBody String jsonBody) {

        JSONObject json = new JSONObject(jsonBody);
        String command = json.optString("command", "");
        if (json.optBoolean("sudo", false)) {
            command = "echo '" + json.optString("password", "") + "' | sudo -S " + command;
        }
        try {
            ProcessBuilder processBuilder = new ProcessBuilder("bash", "-c", command)
                    .directory(new File(json.optString("path", "")))
                    .redirectErrorStream(true);
            Process process = processBuilder.start();
            BufferedReader reader = new BufferedReader(new InputStreamReader(process.getInputStream()));
            StringBuilder output = new StringBuilder();
            String line;

            while ((line = reader.readLine()) != null) {
                output.append("\n").append(line);
            }
            process.waitFor();
            return ResponseEntity.ok(output.toString().replace("[sudo] contraseña para wildfly: ",""));
        } catch (IOException | InterruptedException e) {
            throw new RuntimeException(e);
        }
    }
}